/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.specialevent.RunawaySpyBattleHandler
 *  fire.pb.battle.specialevent.SpecialHideBattleHandler
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.SMineArea
 *  fire.pb.util.Misc
 *  fire.pb.util.Parser
 *  fire.pb.util.Parser$ID2Odds
 *  fire.script.ParseStringExpression
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  org.apache.log4j.Logger
 */
package fire.pb.battle;

import fire.pb.battle.BattleConfigManager;
import fire.pb.battle.BattleEndHandler;
import fire.pb.battle.BattleField;
import fire.pb.battle.Module;
import fire.pb.battle.Monster;
import fire.pb.battle.PNewBattle;
import fire.pb.battle.specialevent.RunawaySpyBattleHandler;
import fire.pb.battle.specialevent.SpecialHideBattleHandler;
import fire.pb.main.ConfigManager;
import fire.pb.map.SMineArea;
import fire.pb.util.Misc;
import fire.pb.util.Parser;
import fire.script.ParseStringExpression;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;
import javax.script.ScriptException;
import mkdb.Procedure;
import mkdb.Transaction;
import org.apache.log4j.Logger;

public class HideBattle {
    private final long roleID;
    private final int teamsize;
    private final int areaconf;
    private int monstertype = 0;
    public static final int HIDEBATTLE_TYPE_COMMON = 0;
    public static final int HIDEBATTLE_TYPE_BABY = 1;
    public static final int HIDEBATTLE_TYPE_BOSS = 2;
    public static final int HIDEBATTLE_TYPE_SPECIAL = 3;
    public static final Logger logger = Logger.getLogger((String)"BATTLE");
    public static Random random = new Random();
    private static ParseStringExpression pse = new ParseStringExpression();
    private static Map<String, Object> pseParas = new HashMap<String, Object>();
    BattleEndHandler handler = null;

    public HideBattle(long roleID, int areaconf, int teamsize) {
        this.roleID = roleID;
        this.areaconf = areaconf;
        this.teamsize = teamsize;
    }

    public int getMonsterNum() {
        int monsterNum = Misc.getRandomBetween((int)this.teamsize, (int)(25 * (this.teamsize + 1) / 14));
        logger.debug((Object)("teamsize:" + this.teamsize + "monsterNum:" + monsterNum));
        return monsterNum;
    }

    public void setBattleEndHandler(BattleEndHandler handler) {
        this.handler = handler;
    }

    public void launch() {
        SMineArea areaInfo = (SMineArea)ConfigManager.getInstance().getConf(SMineArea.class).get(this.areaconf);
        if (null == areaInfo) {
            return;
        }
        int commonrate = this.calBattleTypeRate(areaInfo.commonrate);
        int babyrate = this.calBattleTypeRate(areaInfo.babyrate);
        int bossrate = this.calBattleTypeRate(areaInfo.bossrate);
        int specialrate = this.calBattleTypeRate(areaInfo.specialrate);
        int[] probs = new int[]{commonrate, babyrate, bossrate, specialrate};
        this.monstertype = Misc.getProbability((int[])probs, (int)10000, (Random)random);
        if (-1 == this.monstertype) {
            return;
        }
        BattleConfigManager.MonsterNumConfig monsternumConf = Module.getInstance().getBattleConfigManager().getMonsterNumConfig(this.teamsize);
        if (monsternumConf == null) {
            return;
        }
        LinkedList<Integer> monsterIDs = new LinkedList<Integer>();
        switch (this.monstertype) {
            case 0: {
                int index;
                int i;
                for (i = 0; i < monsternumConf.getNormalnum(); ++i) {
                    index = Misc.getProbability((List)areaInfo.getMonsterrate(), (int)1000);
                    monsterIDs.add((Integer)areaInfo.getMonster().get(index));
                }
                for (i = 0; i < monsternumConf.getHeadnum(); ++i) {
                    index = Misc.getProbability((List)areaInfo.getLeaderrate(), (int)1000);
                    monsterIDs.add((Integer)areaInfo.getLeader().get(index));
                }
                break;
            }
            case 1: {
                int s;
                int index = Misc.getProbability((List)areaInfo.getPetrate(), (int)1000);
                monsterIDs.add((Integer)areaInfo.getPet().get(index));
                for (int i = 1; i < monsternumConf.getNormalnum(); ++i) {
                    int idx = Misc.getProbability((List)areaInfo.getMonsterrate(), (int)1000);
                    monsterIDs.add((Integer)areaInfo.getMonster().get(idx));
                }
                for (int i = s = monsternumConf.getNormalnum() > 0 ? 0 : 1; i < monsternumConf.getHeadnum(); ++i) {
                    int idx = Misc.getProbability((List)areaInfo.getLeaderrate(), (int)1000);
                    monsterIDs.add((Integer)areaInfo.getLeader().get(idx));
                }
                break;
            }
            case 2: {
                int battleid = areaInfo.getBossbattleid();
                PNewBattle newbattle = null;
                newbattle = this.handler == null ? new PNewBattle(this.roleID, battleid) : new PNewBattle(this.roleID, battleid, this.handler);
                newbattle.setAreaConf(this.areaconf);
                newbattle.setAreaType(1);
                newbattle.setMonsterType(this.monstertype);
                newbattle.setBattleType(30);
                if (Transaction.current() != null) {
                    Procedure.pexecute((Procedure)newbattle);
                } else {
                    newbattle.submit();
                }
                return;
            }
            case 3: {
                Parser.ID2Odds id2odds = Parser.parseIdAndOdds((String)areaInfo.getSpecialevents());
                int battleconfId = id2odds.ids[Misc.getProbability((int[])id2odds.odds)];
                this.handler = battleconfId >= 9116 && battleconfId <= 9199 ? new RunawaySpyBattleHandler() : new SpecialHideBattleHandler();
                PNewBattle newbattle = new PNewBattle(this.roleID, battleconfId, this.handler);
                newbattle.setAreaConf(this.areaconf);
                newbattle.setAreaType(1);
                newbattle.setMonsterType(this.monstertype);
                if (Transaction.current() != null) {
                    Procedure.pexecute((Procedure)newbattle);
                } else {
                    newbattle.submit();
                }
                return;
            }
        }
        if (monsterIDs.size() != 0) {
            List<Monster> monsters = BattleField.genMonsters(monsterIDs);
            PNewBattle batproc = this.handler == null ? new PNewBattle(this.roleID, monsters) : new PNewBattle(this.roleID, monsters, this.handler);
            if (this.monstertype == 2) {
                monsters.get(0).setFighterId(15);
                batproc.setBattleType(30);
            } else {
                batproc.setBattleType(1100);
            }
            if (this.monstertype == 1) {
                batproc.setBabyfight(true);
            }
            batproc.setAreaConf(this.areaconf);
            batproc.setAreaType(1);
            batproc.setMonsterType(this.monstertype);
            if (Transaction.current() != null) {
                Procedure.pexecute((Procedure)batproc);
            } else {
                batproc.submit();
            }
        }
    }

    private int calBattleTypeRate(String commonrate) {
        pseParas.put("TeamNum", this.teamsize);
        int rate = 0;
        try {
            Double value = pse.ParseStr(commonrate, pseParas);
            rate = value.intValue();
            return rate;
        }
        catch (ScriptException e) {
            logger.error((Object)("error when parsing battleTypeRate String:" + commonrate), (Throwable)e);
            return 0;
        }
    }
}

